#ifndef DetectorMessenger_h
#define DetectorMessenger_h 1

#include "globals.hh"
#include "G4UImessenger.hh"

class DetectorConstruction;
class G4UIdirectory;
class G4UIcmdWithABool;
class G4UIcmdWithAString;
class G4UIcmdWithAnInteger;
class G4UIcmdWithADoubleAndUnit;
class G4UIcmdWithoutParameter;

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

class DetectorMessenger: public G4UImessenger
{
public:
  DetectorMessenger(DetectorConstruction* );
  virtual ~DetectorMessenger();

  virtual void SetNewValue(G4UIcommand*, G4String);

private:
  DetectorConstruction* Detector;

  G4UIdirectory*             testDir;
  G4UIcmdWithAString*        mattCmd;
  G4UIcmdWithAString*        matwCmd;
  G4UIcmdWithAnInteger*      tnCmd;
  G4UIcmdWithAnInteger*      tlnCmd;
  G4UIcmdWithADoubleAndUnit* txCmd;
  G4UIcmdWithADoubleAndUnit* tyCmd;
  G4UIcmdWithADoubleAndUnit* tzCmd;
  G4UIcmdWithADoubleAndUnit* tgapCmd;
  G4UIcmdWithAnInteger* trotCmd;
  G4UIcmdWithADoubleAndUnit* dxCmd;
  G4UIcmdWithADoubleAndUnit* dyCmd;
  G4UIcmdWithADoubleAndUnit* dzCmd;
  G4UIcmdWithoutParameter*   updateCmd;
};

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

#endif

