#ifndef PrimaryGeneratorAction_h
#define PrimaryGeneratorAction_h 1

#include "G4VUserPrimaryGeneratorAction.hh"
#include "G4ThreeVector.hh"

#include "CParticle.hh"

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

class BeamMessenger;
class G4ParticleGun;
class TRandom3;
class CParticle;
class TF1;

class PrimaryGeneratorAction : public G4VUserPrimaryGeneratorAction
{
public:
  PrimaryGeneratorAction();
  virtual ~PrimaryGeneratorAction();

  virtual void GeneratePrimaries(G4Event*);

  void SetErel(G4double val);
  void SetRatio2m(G4double val);
  void SetRatio1m(G4double val);
  void SetRatio1p(G4double val);
  void SetRatio2p(G4double val);

private:
  PrimaryGeneratorAction & operator=(const PrimaryGeneratorAction &right);
  PrimaryGeneratorAction(const PrimaryGeneratorAction&);

  G4ThreeVector CalculateMomentum();

  BeamMessenger* beamMessenger;
  G4ParticleGun* particleGun;

private:
  TRandom3* random;
  CParticle p1, p2;
  TF1* f2m;
  TF1* f1m;
  TF1* f1p;
  TF1* f2p;
  G4double erel;
  G4double ratio2m;
  G4double ratio1m;
  G4double ratio1p;
  G4double ratio2p;
};

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

#endif


